Bug 239895

Summary: multimedia/gstreamer-ffmpeg: fix build on armv7
Product: Ports & Packages Reporter: Piotr Kubaj <pkubaj>
Component: Individual Port(s)Assignee: freebsd-multimedia mailing list <multimedia>
Status: Closed FIXED    
Severity: Affects Only Me CC: multimedia, riggs
Priority: --- Flags: riggs: maintainer-feedback+
Version: Latest   
Hardware: Any   
OS: Any   
Attachments:
Description Flags
patch pkubaj: maintainer-approval? (multimedia)

Description Piotr Kubaj freebsd_committer 2019-08-16 01:48:24 UTC
Created attachment 206603 [details]
patch

armv7 needs the same fix that i386 needs.
Comment 1 Jan Beich freebsd_committer 2019-08-17 21:57:48 UTC
Comment on attachment 206603 [details]
patch

Looks OK but...
- Add for armv6 as well as LLD behaves similar if forced via -fuse-ld
- Make sure to document error message in commit log, so the line can be dropped in future if the error disappears or someone fixes it in a different way

Such a fix is covered by portmgr blanket, anyway.
Comment 2 Thomas Zander freebsd_committer 2019-08-23 13:51:28 UTC
In ffmpeg we have:

LDFLAGS_aarch64=-Wl,-z,notext
LDFLAGS_armv6=  -Wl,-z,notext
LDFLAGS_armv7=  -Wl,-z,notext
LDFLAGS_i386=   -Wl,-z,notext

It would seem reasonable to have the same in gstreamer-ffmpeg.

But yes, go ahead, commit the fix. It's subject to the build fix blanket, as Jan said.
Comment 3 Mark Linimon freebsd_committer freebsd_triage 2019-08-31 11:15:38 UTC
Mentor approval.
Comment 4 commit-hook freebsd_committer 2019-09-04 09:30:33 UTC
A commit references this bug:

Author: pkubaj
Date: Wed Sep  4 09:30:25 UTC 2019
New revision: 511072
URL: https://svnweb.freebsd.org/changeset/ports/511072

Log:
  multimedia/gstreamer-ffmpeg: fix build on armv6, armv7, aarch64

  LDFLAGS+=-Wl,-z,notext is needed on those.

  PR:		239895
  Submitted by:	riggs (ultimate version)
  Approved by:	linimon (mentor)

Changes:
  head/multimedia/gstreamer-ffmpeg/Makefile
Comment 5 Jan Beich freebsd_committer 2019-09-04 10:39:29 UTC
When landing a fix for bustage make sure to document the error for posterity. Someone in future may want to report it upstream, fix in a better way, confirm when no longer necessary, etc.

For one, passing -Wl,-z,notext is usually only required on 32-bit architectures. When it was added to multimedia/ffmpeg for aarch64 I've documented the error, so anyone can review if the approach is correct, not just blindly trust the committer.